<?
include ("ServerScriptHelper.php");
include ("ArrayPacker.php");
include ("uifc/ImageButton.php");

$serverScriptHelper = new ServerScriptHelper();
$i18n = $serverScriptHelper->getI18n("base-addressbook");
$factory = $serverScriptHelper->getHtmlComponentFactory("base-addressbook");
$page = $factory->getPage();
$scrollList = $factory->getScrollList("addressbookgroupsScrollList", array("groupname", "groupmembers", "groupdesc", "listAction"), array(0));
$scrollList->setEntryCountTags("[[base-addressbook.groupCountSingular]]", "[[base-addressbook.groupCountPlural]]");

$cce = $serverScriptHelper->getCceClient();

// get hostname
$system = $cce->getObject("System");
$hostname = $system["hostname"] . "." . $system["domainname"];

// add speed ups, copied from Kevin's changes in workgroupList.php
// disable sorting
$scrollList->setSortEnabled(false);

// find page length
$pageLength = $scrollList->getLength();

// find start point
$start = $scrollList->getPageIndex()*$pageLength;

$oids = $cce->findSorted("Workgroup", "name");

// sort in the right direction
if($scrollList->getSortOrder() == "descending")
  $oids = array_reverse($oids);

// number of groups
$scrollList->setEntryNum(count($oids));

for($i = $start; $i < count($oids) && $i < $start+$pageLength;$i++) {
	$oid = $oids[$i];
	$group = $cce->get($oid);
	$actions = $factory->getCompositeFormField();
	$actions->addFormField(new ImageButton($page, "/base/webmail/compose.php?toAddy=".rawurlencode($i18n->interpolate("[[base-addressbook.groupEmailFormat]]", array("name" => $group["name"], "email" => $group["name"] . "@" . $hostname))), "/libImage/composeEmail.gif", "groupMail", "groupMail_help"));
	$actions->addFormField(new ImageButton($page, "javascript: window.open('http://$hostname/~" . $group["name"] . "/'); void(0)", "/libImage/visitWebsite.gif", "groupWeb", "groupWeb_help"));

	// this sequence needs to get pushed to a common place
	$desc = $factory->getTextField("", $i18n->interpolate($group["description"]), "r");
	$desc->setMaxLength(1000);
	$scrollList->addEntry( array(
		$factory->getTextField("name".$oid, $group["name"], "r"),
		$factory->getTextField("members".$oid, implode(", ", stringToArray($group["members"])), "r"),
		$desc,
		$actions
	), "", false, $i);
}

print $page->toHeaderHtml();
print $scrollList->toHtml();
print $page->toFooterHtml();
