<?
// Author: Kenneth C.K. Leung
// Copyright 2000, Cobalt Networks.  All rights reserved.
// $Id: addressbookPrivateAdd.php,v 1.4.6.1 2001/12/11 21:38:26 ssmith Exp $

include("ServerScriptHelper.php");
include("ArrayPacker.php");

$serverScriptHelper = new ServerScriptHelper();
$cceClient = $serverScriptHelper->getCceClient();
// $factory = $serverScriptHelper->getHtmlComponentFactory("base-addressbook", "/post.php");
$factory = $serverScriptHelper->getHtmlComponentFactory("base-addressbook", "/base/addressbook/addressbookPrivateAddHandler.php");

// get defaults
$page = $factory->getPage();
$block = $factory->getPagedBlock("addressbookPrivateAdd");

$fullname = $factory->getFullname("fullname");
$block->addFormField($fullname, $factory->getLabel("enterFullname"));

$email = $factory->getEmailAddress("email");
$email->setOptional(true);
$block->addFormField($email, $factory->getLabel("enterEmail"));

$phone = $factory->getTextField("phone");
$phone->setOptional(true);
$block->addFormField($phone, $factory->getLabel("enterPhone"));

$fax = $factory->getTextField("fax");
$fax->setOptional(true);
$block->addFormField($fax, $factory->getLabel("enterFax"));

$homeUrl = $factory->getUrl("homeUrl");
$homeUrl->setOptional(true);
$block->addFormField($homeUrl, $factory->getLabel("enterHomeUrl"));

$address = $factory->getTextBlock("address");
$address->setWidth(2*$address->getWidth());
$address->setWrap(true);
$address->setOptional(true);
$block->addFormField($address, $factory->getLabel("enterAddress"));

$remarks = $factory->getTextBlock("remarks");
$remarks->setWidth(2*$remarks->getWidth());
$remarks->setWrap(true);
$remarks->setOptional(true);
$block->addFormField($remarks, $factory->getLabel("enterRemarks"));

$block->addButton($factory->getSaveButton($page->getSubmitAction()));
$block->addButton($factory->getCancelButton("/base/addressbook/addressbookPrivate.php"));
$serverScriptHelper->destructor();
?>
<?php print($page->toHeaderHtml()); ?>
<?php print($block->toHtml()); ?>
<?php print($page->toFooterHtml()); ?>




