<?
// Author: Kenneth C.K. Leung
// Copyright 2000, Cobalt Networks.  All rights reserved.
// $Id: addressbookPrivateModify.php,v 1.5.6.1 2001/12/11 21:38:26 ssmith Exp $

include("ServerScriptHelper.php");
include("ArrayPacker.php");
include("./addressbookPrivateCommon.php");

$serverScriptHelper = new ServerScriptHelper();
$factory = $serverScriptHelper->getHtmlComponentFactory("base-addressbook", "/base/addressbook/addressbookPrivateModifyHandler.php");

// get addy
$page = $factory->getPage();
$block = $factory->getPagedBlock("addressbookPrivateModify");
$addy = addressBookGet($serverScriptHelper, $oid);

$fullname = $factory->getFullname("fullname",$addy[$FULLNAME]);
$block->addFormField($fullname, $factory->getLabel("enterFullname"));

$email = $factory->getEmailAddress("email", $addy[$EMAIL]);
$email->setOptional(true);
$block->addFormField($email, $factory->getLabel("enterEmail"));

$phone = $factory->getTextField("phone", $addy[$PHONE]);
$phone->setOptional(true);
$block->addFormField($phone, $factory->getLabel("enterPhone"));

$fax = $factory->getTextField("fax", $addy[$FAX]);
$fax->setOptional(true);
$block->addFormField($fax, $factory->getLabel("enterFax"));

$homeUrl = $factory->getUrl("homeUrl", $addy[$HOMEPAGE]);
$homeUrl->setOptional(true);
$block->addFormField($homeUrl, $factory->getLabel("enterHomeUrl"));

$address = $factory->getTextBlock("address", $addy[$ADDRESSES]);
$address->setWidth(2*$address->getWidth());
$address->setWrap(true);
$address->setOptional(true);
$block->addFormField($address, $factory->getLabel("enterAddress"));

$remarks = $factory->getTextBlock("remarks", $addy[$REMARK]);
$remarks->setWidth(2*$remarks->getWidth());
$remarks->setWrap(true);
$remarks->setOptional(true);
$block->addFormField($remarks, $factory->getLabel("enterRemarks"));

$oid = $factory->getTextField("oid",$oid,"");

$block->addButton($factory->getSaveButton($page->getSubmitAction()));
$block->addButton($factory->getCancelButton("/base/addressbook/addressbookPrivate.php"));
$serverScriptHelper->destructor();
?>
<?php print($page->toHeaderHtml()); ?>
<?php print($block->toHtml()); ?>
<?php print($oid->toHtml()); ?>
<?php print($page->toFooterHtml()); ?>




