<?
// Edit user personal profile
// Copyright 2000, Cobalt Networks.  All rights reserved.
// $Id: addressbookPersonal.php,v 1.3.6.1 2001/08/08 03:27:11 mikew Exp $

include("ServerScriptHelper.php");

$serverScriptHelper = new ServerScriptHelper();
$factory = $serverScriptHelper->getHtmlComponentFactory("base-addressbook", "/base/addressbook/addressbookPersonalHandler.php");

$cceClient = $serverScriptHelper->getCceClient();
$loginName = $serverScriptHelper->getLoginName();
$oids = $cceClient->find("User", array("name" => $loginName));

$addr = $cceClient->get($oids[0], "AddressbookEntry");
$user = $cceClient->get($oids[0], "");

// get defaults
$page = $factory->getPage();
$block = $factory->getPagedBlock("addressbookPersonal");

$homeUrl = $factory->getUrl("homeUrl", $addr["homeUrl"]);
$homeUrl->setOptional(true);
$block->addFormField($homeUrl, $factory->getLabel("persHomeUrl"));

$phone = $factory->getTextField("phone", $addr["phone"]);
$phone->setOptional(true);
$block->addFormField($phone, $factory->getLabel("persPhone"));

$fax = $factory->getTextField("fax", $addr["fax"]);
$fax->setOptional(true);
$block->addFormField($fax, $factory->getLabel("persFax"));

$address = $factory->getTextBlock("address", $addr["address"]);
$address->setWidth($address->getWidth()*2);
$address->setWrap(true);
$address->setOptional(true);
$block->addFormField($address, $factory->getLabel("persAddress"));

$remarks = $factory->getTextBlock("remarks", $user["description"]);
$remarks->setWidth($remarks->getWidth()*2);
$remarks->setWrap(true);
$remarks->setOptional(true);
$block->addFormField($remarks, $factory->getLabel("persRemarks"));

$block->addButton($factory->getSaveButton($page->getSubmitAction()));

$serverScriptHelper->destructor();
?>
<?php print($page->toHeaderHtml()); ?>
<?php print($block->toHtml()); ?>
<?php print($page->toFooterHtml()); ?>




